# Documents

A `Document` represents any kind of information that you want to persist for some time. Documents are saved as schema-less data in a database.&#x20;

In addition to the unstructured `content`, which is usually available in JSON, XML or text format, a document has additional, firmly defined properties. These are used to index and group documents `Key, Context, UserId, Rank` or to store user-defined meta information `UserState, UnserInfo, ClientId, ClientVersion` with the document.

The `/Docs` endpoint provides services to Create, Update, to Upsert or Delete documents, as well as to Read (GET) or Query multiple documents.

{% content-ref url="/pages/k9oec6jJr8WUw7nd7wtK" %}
[Document Properties](/mspro.services/endpoints/documents/document-properties.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://services.markusschmidt.pro/mspro.services/endpoints/documents.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
